using System;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Text;

namespace CsCgrep
{
	/// <summary>
	/// CsCgrep̃Oo̓NXłB
	/// </summary>
	public class Log
	{
		/// <summary>
		/// G[Ot@C
		/// </summary>
		private const string ERROR_LOG_FILE_NAME = "cscgrep_error.log";

		/// <summary>
		/// ̃NX̃CX^X
		/// </summary>
		private static Log log = new Log();

		/// <summary>
		/// Oo̓NX쐬܂B
		/// </summary>
		private Log()
		{
		}

		/// <summary>
		/// Oo̓NX̃CX^XԂ܂B
		/// </summary>
		/// <returns>Oo̓NX̃CX^X</returns>
		public static Log GetInstance()
		{
			return log;
		}

		/// <summary>
		/// G[Oo͂܂B
		/// </summary>
		/// <param name="s">G[bZ[W</param>
		public void Error(String s)
		{
			StreamWriter writer = null;

			try
			{
				writer = new StreamWriter(
					Application.StartupPath + "\\" + ERROR_LOG_FILE_NAME,
                    true, // Append
                    Encoding.GetEncoding(Constants.SHIFT_JIS));

				DateTime now = DateTime.Now;

				writer.WriteLine("[" + now + "] " + s);
			}
			catch (Exception e)
			{
				Debug.WriteLine(e.Message);
				Debug.WriteLine(e.StackTrace);
			}
			finally
			{
				if (writer != null)
				{
					writer.Close();
				}
			}
		}
	}
}
